{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                DINA5.PAS                }
{-----------------------------------------}

Program Dina5 ;

{$M 16384,0,655360}

Uses
  Crt,
  Graph ;

Type
  AdatRekMut = ^AdatRek ;
  AdatRek    = Record
                 Szam      : Word ;
                 Kovetkezo : AdatRekMut ;
                 Pozicio   : Byte ;
               End ;

Var
  ElsoRek,
  ElozoRek,
  UjRek,
  AktRek   : AdatRekMut ;
  Meghajto,
  Uzemmod,
  GrafHiba : Integer ;
  I        : Byte ;
  Szam     : Word ;

Function XKozep(Poz: Byte) : Word ;
  Begin
    XKozep := Poz * GetMaxX Div 15 - (GetMaxX Div 30) ;
  End ;

Procedure Uzenet(S : String) ;
  Begin
    SetViewPort(0,GetMaxY - 10,GetMaxX,GetMaxY,ClipOn) ;
    ClearViewPort ;
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn) ;
    SetTextJustify(LeftText,BottomText) ;
    SetColor(White) ;
    OutTextXY(0,GetMaxY,S) ;
    Repeat
    Until ReadKey = ^M ;
  End ;

Procedure ElsoKiir(Poz : Byte) ;
  Begin
    SetViewPort(0,0,GetMaxX,9,ClipOn) ;
    ClearViewPort ;
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn) ;
    SetColor(White) ;
    SetTextJustify(CenterText,TopText) ;

    OutTextXY(XKozep(Poz),0,'Els') ;
  End ;

Procedure RekRajzol(Poz : Byte ; Szam : Word ; Kiemelt : Boolean);
  Var
    S : String ;
  Begin
    SetColor(GetBkColor) ;
    SetLineStyle(SolidLn,0,NormWidth) ;
    Rectangle(XKozep(Poz)-18,10,XKozep(Poz)+18,40) ;
    If Kiemelt
    Then
      SetLineStyle(DottedLn,0,NormWidth)
    Else
      SetLineStyle(SolidLn,0,NormWidth) ;
    SetColor(GetMaxColor) ;
    Rectangle(XKozep(Poz) - 18,10,XKozep(Poz) + 18,40) ;

    Str(Szam,S) ;
    SetTextJustify(CenterText,CenterText) ;
    OutTextXY(XKozep(Poz),25,S) ;
  End ;

Procedure LancRajzolas ;
  Var
    Poz,
    KovPoz,
    I      : Byte ;
    Akt    : AdatRekMut ;
  Begin
    If ElsoRek = Nil Then
      Exit ;

    SetViewPort(0,41,GetMaxX,GetMaxY,ClipOn) ;
    ClearViewPort ;
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn) ;
    SetTextJustify(CenterText,TopText) ;
    SetLineStyle(SolidLn,0,ThickWidth) ;

    Akt := ElsoRek ;
    I := 1 ;
    While Akt^.Kovetkezo <> Nil Do
      Begin
        Poz := Akt^.Pozicio ;
        KovPoz := Akt^.Kovetkezo^.Pozicio ;

        If GetMaxColor > 1
        Then
          SetColor(I Mod GetMaxColor)
        Else
          SetColor(1) ;

        MoveTo(XKozep(Poz) - 5,41) ;
        LineTo(XKozep(Poz) - 5,41 + I * GetMaxY Div 25) ;
        LineTo(XKozep(KovPoz) + 5,41 + I * GetMaxY Div 25) ;
        LineTo(XKozep(KovPoz) + 5,41) ;
        OutText(#30) ;
        Akt := Akt^.Kovetkezo ;
        Inc(I) ;
      End ;

    SetColor(GetMaxColor) ;
    With Akt^ Do
      Begin
        MoveTo(XKozep(Pozicio) - 5,41) ;
        LineTo(XKozep(Pozicio) - 5,41 + I * GetMaxY Div 25) ;
      End ;
    OutText(#31) ;
    OutTextXY(GetX,GetY + 15,'NIL') ;
  End ;

Begin
  Meghajto := Detect ;
  InitGraph(Meghajto,Uzemmod,'') ;
  GrafHiba := GraphResult ;
  If GrafHiba <> grOk Then
    Begin
      WriteLn(GraphErrorMsg(GrafHiba)) ;
      ReadLn ;
      Halt ;
    End ;
  SetGraphMode(0) ;

  Randomize ;
  ElsoRek := Nil ;
  For I := 1 To 15 Do
    Begin
      Uzenet('Uj rekord lefoglalsa <ENTER>re') ;
      New(UjRek) ;
      Szam := Random(100) ;
      UjRek^.Szam := Szam ;
      UjRek^.Pozicio := I ;
      RekRajzol(I,UjRek^.Szam,False) ;

      If ElsoRek <> Nil Then
        Uzenet('Pozici kikeresse <ENTER>re') ;

      AktRek := ElsoRek ;
      ElozoRek := Nil ;
      {$B-}
      While (AktRek <> Nil) And (Szam > AktRek^.Szam) Do
        Begin
          RekRajzol(AktRek^.Pozicio,AktRek^.Szam,True) ;
          Uzenet('Tovbb <ENTER>re') ;
          RekRajzol(AktRek^.Pozicio,AktRek^.Szam,False) ;
          ElozoRek := AktRek ;
          AktRek := AktRek^.Kovetkezo ;
        End ;
      {$B+}

      UjRek^.Kovetkezo := AktRek ;

      If ElozoRek = Nil
      Then
        Begin
          ElsoRek := Ujrek ;
          Uzenet('Az j rekord lesz az els') ;
          ElsoKiir(ElsoRek^.Pozicio) ;
        End
      Else
        Begin
          RekRajzol(ElozoRek^.Pozicio,ElozoRek^.Szam,True) ;
          Uzenet('E mg kell beilleszteni az j rekordot - ' +
                 'tovbb <ENTER>') ;
          RekRajzol(ElozoRek^.Pozicio,ElozoRek^.Szam,False) ;
          ElozoRek^.Kovetkezo := UjRek ;
        End ;
      LancRajzolas ;
    End ;

  Uzenet('Kilps <ENTER>-re') ;
  CloseGraph ;
End.
