{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                DINA6.PAS                }
{-----------------------------------------}

Program Dina6 ;

{$M 16384,0,655360}

Uses
  Crt ;

Const
  NevHossz = 25 ;
  CimHossz = 40 ;

Type
  AdatRekMut  = ^AdatRek ;
  AdatRek     = Record
                  Nev       : String[NevHossz] ;
                  Cim       : String[CimHossz] ;
                  Tel       : LongInt ;
                  Elozo,
                  Kovetkezo : AdatRekMut ;
                End ;

Const
  ElsoAdat : AdatRekMut = Nil ;

Var
  AktualisAdat,
  ElozoAdat     : AdatRekMut ;
  Nev           : String[NevHossz] ;
  C             : Char ;
  Puffer        : Array[1..80] Of Byte ;

Function VanMarIlyenNev : Boolean ;
  Begin
    ElozoAdat := ElsoAdat ;
    AktualisAdat := ElsoAdat ;
    {$B-}
    While (AktualisAdat <> Nil) And (Nev > AktualisAdat^.Nev) Do
      Begin
        ElozoAdat := AktualisAdat ;
        AktualisAdat := AktualisAdat^.Kovetkezo ;
      End ;

    VanMarIlyenNev := (AktualisAdat <> Nil) And
                      (AktualisAdat^.Nev = Nev) ;
    {$B+}
  End ;

Procedure Uzenet(Szoveg : String ; Hang : Boolean) ;
  Begin
    GotoXY(1,25) ;
    ClrEol ;
    Write(Szoveg) ;
    If Hang Then
      Begin
        Sound(1000) ;
        Delay(50) ;
        NoSound ;
        Delay(1000) ;
        GotoXY(1,25) ;
        ClrEol ;
      End ;
  End ;

Procedure NevBekeres ;
  Begin
    GotoXY(20,10) ;
    Write('Nv : ') ;
    SetTextBuf(Input,Puffer,NevHossz + 2) ;
    ReadLn(Nev) ;
  End ;

Procedure TobbiAdatBekeres(Mutato : AdatRekMut) ;
  Var
    T  : String[10] ;
    Ok : Integer ;
  Begin
    GotoXY(20,12) ;
    Write('Cim : ') ;
    SetTextBuf(Input,Puffer,CimHossz + 2) ;
    ReadLn(Mutato^.Cim) ;
    SetTextBuf(Input,Puffer,12) ;
    Repeat
        GotoXY(20,14) ;
        ClrEol ;
        Write('Tel : ') ;
        ReadLn(T) ;
        Val(T,Mutato^.Tel,Ok) ;
    Until (Ok = 0) And (Mutato^.Tel > 0) ;
  End ;

Procedure AdatFelvitel ;
  Var
    UjAdat : AdatRekMut ;
  Begin
    NevBekeres ;
    If VanMarIlyenNev
    Then
      Uzenet('Van mr ilyen nv, nem vihet fel jra',True)
    Else
      Begin
        New(UjAdat) ;
        UjAdat^.Nev := Nev ;
        TobbiAdatBekeres(UjAdat) ;

        If AktualisAdat = ElsoAdat
        Then
          Begin
            If ElsoAdat <> Nil Then
              ElsoAdat^.Elozo := UjAdat ;
            ElsoAdat := UjAdat ;
            UjAdat^.Elozo := Nil ;
          End
        Else
          Begin
            If AktualisAdat <> Nil Then
              AktualisAdat^.Elozo := UjAdat ;
            ElozoAdat^.Kovetkezo := Ujadat ;
            UjAdat^.Elozo := ElozoAdat ;
          End ;

        UjAdat^.Kovetkezo := AktualisAdat ;
      End ;
  End ;

Procedure AdatTorles ;
  Begin
    NevBekeres ;
    If VanMarIlyenNev
    Then
      Begin
        If AktualisAdat = ElsoAdat
        Then
          Begin
            ElsoAdat := AktualisAdat^.Kovetkezo ;
            ElsoAdat^.Elozo := Nil ;
          End
        Else
          Begin
            ElozoAdat^.Kovetkezo := AktualisAdat^.Kovetkezo ;
            If AktualisAdat^.Kovetkezo <> Nil Then
              AktualisAdat^.Kovetkezo^.Elozo := ElozoAdat ;
          End ;
        Dispose(AktualisAdat) ;
      End
    Else
      Uzenet('Nincs ilyen nv, nem trlhet',True) ;
  End ;

Procedure AdatModositas ;
  Begin
    NevBekeres ;
    If VanMarIlyenNev
    Then
      TobbiAdatBekeres(AktualisAdat)
    Else
      Uzenet('Nincs ilyen nv, nem mdosthat',True) ;
  End ;

Procedure Listazas ;
  Var
    C1,
    C2 : Char ;

  Procedure AdatKiiras ;
    Begin
      With AktualisAdat^ Do
        Begin
          GotoXY(20,10) ;
          ClrEol ;
          Write('Nv : ',Nev) ;
          GotoXY(20,12) ;
          ClrEol ;
          Write('Cm : ',Cim) ;
          GotoXY(20,14) ;
          ClrEol ;
          Write('Tel : ',Tel) ;
        End ;
    End ;

  Begin
    AktualisAdat := ElsoAdat ;
    AdatKiiras ;
    Repeat
        Uzenet('Lptets elre/htra a vzszintes' +
               ' kurzorvezrlkkel / ESC - Kilps',False) ;
        C1 := ReadKey ;
        If C1 = #0 Then
          Begin
            C2 := ReadKey ;
            Case C2 Of
              #75 : If AktualisAdat^.Elozo = Nil
                    Then
                      Uzenet('Nincs elz adat',True)
                    Else
                      Begin
                        AktualisAdat := AktualisAdat^.Elozo ;
                        AdatKiiras ;
                      End ;
              #77 : If AktualisAdat^.Kovetkezo = Nil
                    Then
                      Uzenet('Nincs kvetkez adat',True)
                    Else
                      Begin
                        AktualisAdat := AktualisAdat^.Kovetkezo ;
                        AdatKiiras ;
                      End ;
            End ;
          End ;
    Until C1 = ^[ ;
  End ;

Begin
  Repeat
      ClrScr ;
      Uzenet('F - Felvitel / T - Trls / M - Mdosts / ' +
             'L - Listzs / ESC - Kilps',False) ;
      C := UpCase(ReadKey) ;
      Case C Of
        'F'         : AdatFelvitel ;
        'T','M','L' : If ElsoAdat = Nil
                      Then
                        Uzenet('Nincs bevitt adat',True)
                      Else
                        Case C Of
                          'T' : AdatTorles ;
                          'M' : AdatModositas ;
                          'L' : Listazas ;
                        End ;
      End ;
  Until C = ^[ ;
  ClrScr ;
End.
