{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{                DINA8.PAS                }
{-----------------------------------------}

Program Dina8 ;

{$X+}

Uses
  Crt,
  Graph ;

Const
  MaxKulcs = 99 ;

Type
  FaMutato = ^FaRekord ;
  FaRekord = Record
               Bal,
               Jobb  : FaMutato ;
               Kulcs : Integer ;
             End ;

Var
  Meghajto,
  Uzemmod,
  GrafHiba  : Integer ;
  XLepes,
  YLepes,
  TeglaSzel,
  TeglaMag  : Integer ;
  Gyoker    : FaMutato ;
  Kar       : Char ;
  St        : String ;

Procedure Init ;
  Var
   TeglaSzin : Integer ;
  Begin
    TeglaSzel := TextWidth('00') + 2 ;
    TeglaMag := TextHeight('0') * 2 ;
    YLepes := Trunc(TeglaMag * 1.8) ;
    Case Meghajto Of
      HercMono : Teglaszin := 1 ;
      Cga      : TeglaSzin := 2 ;
      Else       TeglaSzin := EgaRed ;
    End ;
    SetFillStyle(SolidFill,TeglaSzin) ;
  End ;

Procedure Torol(X,Y,Hossz: Integer) ;
  Var
    Szin,
    I    : Byte ;
    St   : String[80] ;
  Begin
    Szin := GetColor ;
    SetColor(GetBkColor) ;
    St := '' ;
    For I := 1 To Hossz Do
      St := St + #219 ;
    OutTextXY(X,Y,St) ;
    SetColor(Szin) ;
  End ;

Procedure TeglaRajzol(X,Y: Integer; Szam: Integer) ;
  Var
    St      : String[5] ;
  Begin
    Bar(X - TeglaSzel Div 2 + 1, Y - TeglaMag Div 2 + 1,
        X + TeglaSzel Div 2 - 1, Y + TeglaMag Div 2 - 1) ;
    SetTextJustify(CenterText,CenterText) ;
    SetColor(GetBkColor) ;
    Str(Szam,St) ;
    OutTextXY(X,Y,St) ;
  End ;

Procedure KeretRajzol(X,Y: Integer) ;
  Begin
    Rectangle(X - TeglaSzel Div 2, Y - TeglaMag Div 2,
              X + TeglaSzel Div 2, Y + TeglaMag Div 2) ;
  End ;

Procedure Beszur ;
  Var
    Aktualis,
    Uj,
    Szulo    : FaMutato ;
    UjKulcs  : Integer ;
    KulcsSt  : String[5] ;
    Szint,
    XPoz,
    YPoz     : Integer ;
  Begin
    UjKulcs := Random(MaxKulcs) + 1 ;
    Str(UjKulcs,KulcsSt) ;

    Aktualis := Gyoker ;
    Szint := 0 ;
    XLepes := GetMaxX Div 2 ;
    XPoz := GetMaxX Div 2 ;
    YPoz := TeglaMag + 10 ;
    While Aktualis <> Nil Do
      Begin
        Inc(Szint) ;
        XLepes := XLepes Shr 1 ;

        SetColor(GetMaxColor) ;
        KeretRajzol(XPoz,YPoz) ;
        SetTextJustify(CenterText,TopText) ;
        OutTextXY(XPoz,YPoz + TeglaMag Div 2 + 2,KulcsSt + '?');

        SetTextJustify(CenterText,BottomText) ;
        Torol(GetMaxX Div 2,GetMaxY,36) ;
        OutTextXY(GetMaxX Div 2,GetMaxY,
                  'Tovbb keress - <ENTER>');
        Repeat
        Until ReadKey = #13 ;
        SetColor(GetBkColor) ;
        KeretRajzol(XPoz,YPoz) ;
        SetTextJustify(CenterText,TopText) ;
        Torol(XPoz,YPoz + TeglaMag Div 2 + 2,
              Length(KulcsSt + '?')) ;
        Szulo := Aktualis ;
        If UjKulcs < Aktualis^.Kulcs
        Then
          Begin
            Aktualis := Aktualis^.Bal ;
            Dec(XPoz,XLepes) ;
          End
        Else
          Begin
            Aktualis := Aktualis^.Jobb ;
            Inc(XPoz,XLepes) ;
          End ;
        Inc(YPoz,YLepes) ;
      End ;

    If (YPoz >= GetMaxY - TeglaMag) Or (XLepes < TeglaSzel) Then
      Begin
        SetTextJustify(CenterText,TopText) ;
        Torol(GetMaxX Div 2,1,25) ;
        SetColor(GetMaxColor) ;
        OutTextXY(GetMaxX Div 2,1,
                  KulcsSt + ' nem frt r a fra!') ;
        Exit ;
      End ;

    New(Uj) ;
    Uj^.Kulcs := UjKulcs ;
    Uj^.Bal := Nil ;
    Uj^.Jobb := Nil ;

    TeglaRajzol(XPoz,YPoz,UjKulcs) ;
    SetColor(GetMaxColor) ;
    If Aktualis = Gyoker
    Then
      Gyoker := Uj
    Else
      Begin
        MoveTo(XPoz,YPoz - TeglaMag Div 2) ;
        LineRel(0,- (YLepes - TeglaMag Div 2)) ;
        If UjKulcs < Szulo^.Kulcs
        Then
          Begin
            Szulo^.Bal := Uj ;
            LineRel((XLepes - TeglaSzel Div 2),0) ;
          End
        Else
          Begin
            Szulo^.Jobb := Uj ;
            LineRel(-(XLepes - TeglaSzel Div 2),0) ;
          End ;
      End ;
  End ;

Function FaMeret(Gyoker: FaMutato) : LongInt ;
  Begin
    If Gyoker = Nil
    Then
      FaMeret := 0
    Else
      FaMeret := 1 + FaMeret(Gyoker^.Bal) + FaMeret(Gyoker^.Jobb);
  End ;

Begin
  Meghajto := Detect ;
  InitGraph(Meghajto,Uzemmod,'') ;
  GrafHiba := GraphResult ;
  If GrafHiba <> grOk Then
    Begin
      WriteLn(GraphErrorMsg(GrafHiba)) ;
      ReadLn ;
      Halt ;
    End ;
  SetGraphMode(0) ;
  Init ;

  Randomize ;
  Gyoker := Nil ;
  Randomize ;
  Repeat
      Str(FaMeret(Gyoker),St) ;
      SetTextJustify(LeftText,TopText) ;
      Torol(1,1,Length(St)) ;
      SetColor(GetMaxColor) ;
      OutTextXY(1,1,St) ;

      SetTextJustify(CenterText,BottomText) ;
      Torol(GetMaxX Div 2,GetMaxY,36) ;
      OutTextXY(GetMaxX Div 2,GetMaxY,
                'Uj elem - <ENTER>    Kilps - <ESC>') ;
      Repeat
        Kar := ReadKey ;
      Until Kar In [#13,#27] ;
      If Kar <> #27 Then
        Beszur ;
  Until Kar = #27 ;
  CloseGraph ;
End.
