{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              SZOVEG10.PAS               }
{-----------------------------------------}

Program Szoveg10 ;

{$V-,I-}
{$M 65520,0,655360}

Uses
  Crt,
  Dos,
  Printer ;
Const
  IOhiba     = $08 ;
  Papirhiany = $20 ;
  OK         = $10 ;

Var
  I      : Byte ;
  Valasz : Char ;

Function NyomtatoAllapot : Byte ;
  Var
    Regiszterek : Registers ;
  Begin
    With Regiszterek Do
      Begin
        AH := 2 ;		
        DX := 0 ;		
        Intr($17,Regiszterek) ;
        NyomtatoAllapot := AH And $39 ;
      End
  End ;

  Procedure KarNyomtat(C : Char) ;
    Var
      Regiszterek : Registers ;
    Begin
      If NyomtatoAllapot = OK Then
        With Regiszterek Do
          Begin
            AH := 0 ;		
            AL := Ord(C) ;
            DX := 0 ;
            Intr($17,Regiszterek) ;
          End ;
    End ;

Procedure AllomanyNyomtatas(AllomanyNev : String ;
                            Eltolas: Byte);
  Var
    SzovegAll : Text ;
    Karakter,
    C         : Char ;
    I,
    X         : Byte ;

  Begin
    AllomanyNev := FExpand(AllomanyNev) ;
    Assign(SzovegAll,AllomanyNev) ;
    Reset(SzovegAll) ;
    If IOResult <> 0
    Then
      Begin
        GotoXY(Eltolas,WhereY) ;
        WriteLn(AllomanyNev,' nem tallhat') ;
      End
    Else
      Begin
        GotoXY(Eltolas,WhereY) ;
        WriteLn(AllomanyNev,' a pufferben') ;
        While Not Eof(SzovegAll) Do
          Begin
            Read(SzovegAll,Karakter) ;
            KarNyomtat(Karakter)
          End ;
        KarNyomtat(^L) ;
        Close(SzovegAll) ;
      End ;
  End ;

Procedure AllomanyokNyomtatasa(AllomanyNevek : String ;
                               Eltolas : Byte) ;
  Var
    DirInfo   : SearchRec ;
    Utvonal   : PathStr ;
    Nev       : NameStr ;
    Kit       : ExtStr ;
  Begin
    AllomanyNevek := FExpand(AllomanyNevek) ;
    FSplit(AllomanyNevek,Utvonal,Nev,Kit) ;

    FindFirst(AllomanyNevek,AnyFile,DirInfo) ;
    If DosError <> 0
    Then
      Begin
        GotoXY(Eltolas,WhereY) ;
        WriteLn(AllomanyNevek,' nem tallhat')
      End
    Else
      While DosError = 0 Do
        Begin
          If DirInfo.Attr And
             (Directory Or VolumeId Or SysFile) = 0 Then
            AllomanyNyomtatas(Utvonal + DirInfo.Name,Eltolas) ;
          FindNext(DirInfo) ;
        End ;
  End ;

Procedure ListaAllomanyFeld(ListaAllomanyNev : String ;
                            Eltolas : Byte) ;
  Var
    ListaAllomany : Text ;
    ListaSor      : String ;
    DirInfo       : SearchRec ;
    Utvonal       : PathStr ;
    Nev           : NameStr ;
    Kit           : ExtStr ;
  Begin
    ListaAllomanyNev := FExpand(ListaAllomanyNev) ;

    FSplit(ListaAllomanyNev,Utvonal,Nev,Kit) ;

    FindFirst(ListaAllomanyNev,AnyFile,DirInfo) ;
    If DosError <> 0
    Then
      Begin
        GotoXY(Eltolas,WhereY) ;
        WriteLn(ListaAllomanyNev,' nem tallhat') ;
      End
    Else
      While DosError = 0 Do
        Begin
          GotoXY(Eltolas,WhereY) ;
          WriteLn(Utvonal,DirInfo.Name,' feldolgozsa:') ;
          Assign(ListaAllomany,Utvonal + DirInfo.Name) ;
          Reset(ListaAllomany) ;

          While Not Eof(ListaAllomany) Do
            Begin
              ReadLn(ListaAllomany,ListaSor) ;
              If Copy(ListaSor,1,1) <> ';' Then
                If Copy(ListaSor,1,1) = '@'
                Then
                  ListaAllomanyFeld(Copy(ListaSor,2,
                                    Length(ListaSor)),
                                    Eltolas + 3)
                Else
                  AllomanyokNyomtatasa(ListaSor,Eltolas + 3) ;
            End ;
          FindNext(DirInfo) ;
        End ;
  End ;

Begin
  ClrScr ;
  If ParamCount < 1 Then
    Begin
      WriteLn('Hasznlat: SZOVEG10 [@]llomnynv ',
              '[[@]llomnynv ...]') ;
      ReadLn ;
      Halt ;
    End ;

  While NyomtatoAllapot <> OK  Do
    Begin
      Case NyomtatoAllapot Of
        IOHiba+Papirhiany : WriteLn('Kifogyott a papr!') ;
        IOhiba            : WriteLn('Kapcsolja be a nyomtatt!') ;
        Else                WriteLn('Nyomtat hiba.') ;
      End ;
      Write(#7'Folytassam? (I/N)') ;
      Repeat
        Valasz := Upcase(ReadKey) ;
      Until Valasz In ['I','N'] ;
      WriteLn ;
      If Valasz = 'N' Then
        Halt ;
    End ;

  I := 1 ;
  While I <= ParamCount Do
    Begin
      If Copy(ParamStr(I),1,1) = '@'
      Then
        ListaAllomanyFeld(Copy(ParamStr(I),2,Length(ParamStr(I))),1)
      Else
        AllomanyokNyomtatasa(FExpand(ParamStr(I)),1) ;
      Inc(I) ;
    End ;
End.
