{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               SZOVEG8.PAS               }
{-----------------------------------------}

Program Szoveg8 ;

{$DEFINE Nyomtato}

Uses
  Crt
  {$IFDEF Nyomtato}
    ,Printer
  {$ENDIF} ;

Const
  FszavakSzama    = 48 ;
  Betuk           = ['A'..'Z','a'..'z','_'] ;
  Szamok          = ['0'..'9'] ;
  Megjegyzes_nyit = '{' ;
  Megjegyzes_zar  = '}' ;
  Aposztrof       = '''' ;

  {$IFDEF Nyomtato}
    PrInit    = #27 + '@' ;
    Dolt      = #27 + '4' ;
    Doltki    = #27 + '5' ;
    Kiemelt   = #27 + 'E' ;
    KiemeltKi = #27 + 'F' ;
    LapDob    = #12 ;
  {$ELSE}
    PrInit    = '' ;
    Dolt      = '' ;
    Doltki    = '' ;
    Kiemelt   = '' ;
    KiemeltKi = '' ;
    LapDob    = '' ;
  {$ENDIF}
Type
  St15        = String[15] ;

Const
  Fenntartott : Array[1..FszavakSzama] Of St15 =
    ('AND','ASM','ARRAY','BEGIN','CASE','CONST','CONSTRUCTOR',
     'DESTRUCTOR','DIV','DO','DOWNTO','ELSE','END','FILE','FOR',
     'FUNCTION','GOTO','IF','IMPLEMENTATION','IN','INLINE',
     'INTERFACE','LABEL','MOD','NIL','NOT','OBJECT','OF','OR',
     'PACKED','PROCEDURE','PROGRAM','RECORD','REPEAT','SET','SHL',
     'SHR','STRING','THEN','TO','TYPE','UNIT','UNTIL','USES',
     'VAR','WHILE','WITH','XOR') ;

Var
  F       : 1..FszavakSzama ;
  PasProg : Text ;
  ProgNev : String ;
  Vege    : Boolean ;

  {$IFNDEF Nyomtato}
    Lst   : Text ;
  {$ENDIF}

  I       : Byte ;
  Sor     : String ;
  N       : Word ;
  Ch      : Char ;

Procedure Olvas(Var Ch: Char) ;
  Begin
    Vege := Eof(PasProg) ;
    If Not Vege Then
      Read(PasProg,Ch) ;
  End;

Function Nagy(S : St15) : St15 ;
  Var
    I : Byte ;
  Begin
    For I := 1 to Length(S) Do
      S[I] := Upcase(S[I]) ;
    Nagy := S ;
  End ;

Function NagyKicsi(S : String) : String ;
  Var
    I : Byte ;
  Begin
    S[1] := Upcase(S[1]) ;
    For I := 2 to Length(S) Do
      If S[I] In ['A'..'Z'] Then
        S[I] := Chr(Ord(S[I]) + 32) ;
    NagyKicsi := S ;
  End ;

Procedure Megjegyzes_Kiir ;
  Var
    Megjegyzes : String ;
  Begin
    Megjegyzes := '' ;
    Olvas(Ch) ;
    While (Ch <> Megjegyzes_zar) And Not Vege Do
      Begin
        Megjegyzes := Megjegyzes + Ch ;
        Olvas(Ch) ;
      End ;

    Write(Lst,Dolt,Megjegyzes_Nyit,Megjegyzes,Megjegyzes_Zar,
          DoltKi) ;
    Olvas(Ch) ;
  End ;

Procedure Karlanc_Kiir ;
  Var
    Karlanc : String ;
  Begin
    Karlanc := '' ;
    Olvas(Ch) ;
    While (Ch <> Aposztrof) And Not Vege Do
      Begin
        Karlanc := Karlanc + Ch ;
        Olvas(Ch) ;
      End ;

    Write(Lst,Aposztrof,Karlanc,Aposztrof) ;
    Olvas(Ch) ;
  End ;

Procedure Azon_Kiir ;
  Var
    Azon,
    Fenn  : String ;
  Begin
    Azon := '' ;
    Repeat
        Azon := Azon + Ch ;
        Olvas(Ch) ;
    Until Not (Ch In Betuk + Szamok) Or Vege ;

    N := 1 ;
    Fenn := Nagy(Azon) ;
    While (Fenn <> Fenntartott[N]) And (N < FszavakSzama) Do
      Inc(N) ;
    If Fenn = Fenntartott[N]
    Then
      Write(Lst,Kiemelt,Fenn,KiemeltKi)
    Else
      Write(Lst,NagyKicsi(Azon)) ;
  End ;

Procedure Spec_Kiir ;
  Begin
    Repeat
        Write(Lst,Ch) ;
        Olvas(Ch) ;
    Until (Ch In Betuk + [Megjegyzes_nyit] + [Aposztrof]) Or
           Vege ;
  End ;

Begin
  ProgNev := ParamStr(1) ;
  If ProgNev = '' Then
    Begin
      WriteLn('Hasznlat: SZOVEG8 <forrsllomny[.PAS]>') ;
      ReadLn ;
      Halt ;
    End ;

  If Nagy(Copy(ProgNev,Length(ProgNev) - 3,4)) <> '.PAS' Then
    ProgNev := ProgNev + '.PAS' ;
  Assign(PasProg,ProgNev) ;
  {$I-}
  Reset(PasProg) ;
  {$I+}
  If IOResult <> 0 Then
    Begin
      WriteLn('A(z) ',ProgNev,' llomny nem tallhat') ;
      ReadLn ;
      Halt ;
    End ;

  {$IFNDEF Nyomtato}
    Assign(Lst,'CON') ;
    Rewrite(Lst) ;
  {$ENDIF}

  Write(Lst,PrInit) ;
  Olvas(Ch) ;
  While Not Vege Do
    Begin
      Case Ch Of
        Megjegyzes_nyit       : Megjegyzes_Kiir ;
        Aposztrof             : Karlanc_Kiir ;
        'A'..'Z','a'..'z','_' : Azon_Kiir ;
        Else                    Spec_Kiir ;
      End ;
      {$IFNDEF Nyomtato}
        Delay(50) ;
      {$ENDIF}
    End ;

  Close(PasProg) ;
  Write(Lst,LapDob) ;
End.
