{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{              TIPALL14.PAS               }
{-----------------------------------------}

Program Tipall14 ;

Uses
  Crt ;

Const
  MaxKulcs = 1000 ;

Type
  St20        = String[20] ;
  KulcsTip    = String[15] ;
  KulcsRekTip = Record
                  Kulcs : KulcsTip ;
                  Reksz : LongInt ;
                End ;
  TorzsRekTip = Record
                  Torolt : Boolean ;
                  Kulcs  : KulcsTip ;
                  Egyeb  : String[200] ;
                End ;

Var
  TorzsAll     : File Of TorzsRekTip ;
  TorzsRek     : TorzsRekTip ;
  KulcsTomb    : Array [1..MaxKulcs] Of KulcsRekTip ;
  KulcsAll     : File Of KulcsRekTip ;
  KulcsokSzama : LongInt ;
  Ch           : Char ;

Procedure KulcsAll_Beolvas ;
  Var
    I : LongInt ;
  Begin
    KulcsokSzama := FileSize(KulcsAll) ;
    For I := 1 To KulcsokSzama Do
      Read(KulcsAll,KulcsTomb[I]) ;
  End ;

Procedure KulcsTomb_Kiir ;
  Var
    I : LongInt ;
  Begin
    Rewrite(KulcsAll) ;
    For I := 1 To KulcsokSzama Do
      Write(KulcsAll,KulcsTomb[I]) ;
    Close(KulcsAll) ;
  End ;

Function Van(Kulcs: KulcsTip ; Var Poz: LongInt): Boolean ;
  Var
    Tovabb : Boolean ;
  Begin
    Poz := 1 ;
    Tovabb := True ;
    Van := False ;
    While (Poz <= KulcsokSzama) And Tovabb Do
      Begin
        Tovabb := Kulcs > KulcsTomb[Poz].Kulcs ;
        If Tovabb
        Then
          Inc(Poz)
        Else
          Van := Kulcs = KulcsTomb[Poz].Kulcs ;
      End ;
  End ;

Procedure Kulcs_Beszur(Poz, Reksz: LongInt) ;
  Var
    I : LongInt ;
  Begin
    For I := KulcsokSzama Downto Poz Do
      KulcsTomb[I + 1] := KulcsTomb[I] ;
    KulcsTomb[Poz].Kulcs := TorzsRek.Kulcs ;
    KulcsTomb[Poz].Reksz := Reksz ;
    Inc(KulcsokSzama) ;
  End ;

Procedure KulcsTomb_Felepit ;
  Var
    Poz,
    TorzsPoz : LongInt ;
  Begin
    KulcsokSzama := 0 ;
    For TorzsPoz := 0 To FileSize(TorzsAll) - 1 Do
      Begin
        Read(TorzsAll,TorzsRek) ;
        If Not TorzsRek.Torolt And 
           Not Van(TorzsRek.Kulcs,Poz) Then
          Kulcs_Beszur(Poz,TorzsPoz) ;
      End ;
  End ;

Procedure Surit ;
  Var
    UjTorzsAll : File Of TorzsRekTip ;
    I          : LongInt ;
  Begin
    Reset(TorzsAll) ;
    Assign(UjTorzsAll,'UjTorzs.Dat') ;
    Rewrite(UjTorzsAll) ;
    For I := 1 To KulcsokSzama Do
      Begin
        Seek(TorzsAll,KulcsTomb[I].Reksz) ;
        Read(TorzsAll,TorzsRek) ;
        Write(UjTorzsAll,TorzsRek) ;
        KulcsTomb[I].Reksz := I-1 ;
      End ;
    Close(TorzsAll) ;
    Close(UjTorzsAll) ;
    Erase(TorzsAll) ;
    Rename(UjTorzsAll,'Torzs.Dat') ;
  End ;

Procedure Kulcs_Beolvas ;
  Begin
    GotoXY(30,20) ; Write('Kulcs = ') ;
    ReadLn(TorzsRek.Kulcs) ;
  End ;

Procedure Egyeb_Beolvas ;
  Begin
    GotoXY(30,21) ; Write('Egyb = ') ;
    ReadLn(TorzsRek.Egyeb) ;
  End ;

Procedure HibaUzenet(HibaSt: St20) ;
  Begin
    GotoXY(25,25) ;
    Write(HibaSt + ' <ENTER>') ;
    Repeat
    Until ReadKey = #13 ;
  End ;

Procedure Felvitel ;
  Var
    Poz,
    TorzsPoz : LongInt ;
  Begin
    If KulcsokSzama = MaxKulcs Then
      Begin
        HibaUzenet('Betelt!') ;
        Exit ;
      End ;
    Kulcs_Beolvas ;
    If Van(TorzsRek.Kulcs,Poz)
    Then
      HibaUzenet('Mr van ilyen kulcs')
    Else
      Begin
        Egyeb_Beolvas ;
        TorzsPoz := FileSize(TorzsAll) ;
        Seek(TorzsAll,TorzsPoz) ;
        TorzsRek.Torolt := False ;
        Write(TorzsAll,TorzsRek) ;
        Kulcs_Beszur(Poz,TorzsPoz) ;
      End ;
    Close(TorzsAll) ;
    Reset(TorzsAll) ;
  End ;

Procedure Torles ;
  Var
    Poz,
    I    : LongInt ;
  Begin
    Kulcs_Beolvas ;
    If Van(TorzsRek.Kulcs,Poz)
    Then
      Begin
        Seek(TorzsAll,KulcsTomb[Poz].Reksz) ;
        Read(TorzsAll,TorzsRek) ;
        TorzsRek.Torolt := True ;
        Seek(TorzsAll,KulcsTomb[Poz].Reksz) ;
        Write(TorzsAll,TorzsRek) ;
        For I := Poz + 1 To KulcsokSzama Do
          KulcsTomb[I - 1] := KulcsTomb[I] ;
        Dec(KulcsokSzama) ;
      End
    Else
      HibaUzenet('Nincs ilyen kulcs') ;
  End ;

Procedure Modositas ;
  Var
    Poz,
    I    : LongInt ;
  Begin
    Kulcs_Beolvas ;
    If Van(TorzsRek.Kulcs,Poz)
    Then
      Begin
        Seek(TorzsAll,KulcsTomb[Poz].Reksz) ;
        Read(TorzsAll,TorzsRek) ;
        Egyeb_Beolvas ;
        Seek(TorzsAll,KulcsTomb[Poz].Reksz) ;
        Write(TorzsAll,TorzsRek) ;
      End
    Else
      HibaUzenet('Nincs ilyen kulcs') ;
  End ;

Procedure Lista ;
  Var
    I : LongInt ;
  Begin
    ClrScr ;
    WriteLn('Kulcs              Egyb') ;
    WriteLn('') ;
    For I := 1 To KulcsokSzama Do
      Begin
        Seek(TorzsAll,KulcsTomb[I].Reksz) ;
        Read(TorzsAll,TorzsRek) ;
        With TorzsRek Do
          Begin
            GotoXY( 1,WhereY) ; Write(Kulcs) ;
            GotoXY(20,WhereY) ; WriteLn(Egyeb) ;
          End ;
      End ;
    Write('<ENTER>') ;
    ReadLn ;
  End ;

Begin
  Assign(TorzsAll,'Torzs.Dat') ;
  Assign(KulcsAll,'Kulcs.Dat') ;
  {$I-}
  Reset(TorzsAll) ;
  {$I+}
  If IOResult = 0
  Then
    Begin
      {$I-}
      Reset(KulcsAll) ;
      {$I+}
      If IOResult = 0
      Then
        Begin
          KulcsAll_Beolvas ;
          Close(KulcsAll) ;
        End
      Else
        KulcsTomb_Felepit ;
    End
  Else
    Begin
      Rewrite(TorzsAll) ;
      KulcsokSzama := 0 ;
    End ;

  Repeat
      ClrScr ;
      GotoXY(30,10) ; Write ('Felvitel.....F') ;
      GotoXY(30,11) ; Write ('Mdosts....M') ;
      GotoXY(30,12) ; Write ('Trls.......T') ;
      GotoXY(30,13) ; Write ('Lista........L') ;
      GotoXY(30,14) ; Write ('Vge.........V') ;
      Repeat
        Ch := Upcase(ReadKey) ;
      Until Ch In ['F','M','T','L','V'] ;
      Case Ch Of
        'F' : Felvitel ;
        'M' : Modositas ;
        'T' : Torles ;
        'L' : Lista ;
      End ;
  Until Ch = 'V' ;

  If FileSize(TorzsAll) - KulcsokSzama > 10 
  Then
    Surit
  Else
    Close(TorzsAll) ;

  KulcsTomb_Kiir ;
End.
