{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB11.PAS                }
{-----------------------------------------}

Program Tomb11 ;

{$M 50000,0,655360}

{$X+}

Uses
  Crt,
  Dos ;

Const
  Elemszam = 500 ;
  MinKulcs = -9999 ;
  MaxKulcs =  9999 ;

Type
  ElemTip = Record
              Kulcs : Integer ;
              Egyeb : String[20] ;
            End ;
  TombTip = Array [0..Elemszam] Of ElemTip ;

Var
  Tomb     : TombTip ;
  I        : Word ;
  IdoKezd,
  IdoVeg   : LongInt ;

Function SzazadMasodPerc : LongInt ;
  Const
    Egy : LongInt = 1 ;
  Var
    Ora,
    Perc,
    MPerc,
    SzMPerc : Word ;
  Begin
    GetTime(Ora, Perc, MPerc, SzMPerc) ;
    SzazadMasodPerc := Egy * 100 * (60 * (60 * Ora + Perc) + MPerc) + SzMPerc ;
  End ;

Procedure StopperBe ;
  Begin
    IdoKezd := SzazadMasodPerc ;
  End ;

Procedure StopperKi ;
  Begin
    IdoVeg := SzazadMasodPerc ;
  End ;

Function IdoMp : Real ;
  Begin
    IdoMp := (IdoVeg - IdoKezd) / 100 ;
  End ;

Procedure Varj ;
  Begin
    Write('Tovbb <ENTER>') ;
    While KeyPressed Do
      ReadKey ;
    Repeat
    Until ReadKey = #13 ;
    WriteLn ;
  End ;

Procedure Tomb_General ;
  Var
    I : Word ;
  Begin
    Randomize ;
    Tomb[0].Kulcs := 0 ;
    Tomb[0].Egyeb := '' ;
    For I := 1 To Elemszam Do
      Begin
        Tomb[I].Kulcs := Random(MaxKulcs - MinKulcs + 1) + MinKulcs ;
        Str(Tomb[I].Kulcs,Tomb[I].Egyeb) ;
        Tomb[I].Egyeb := 'Elem ' + Tomb[I].Egyeb ;
      End ;
  End ;

Procedure Kulcs_Kiir(Var T: TombTip) ;
  Var
    I : Word ;
  Begin
    For I := 1 To Elemszam Do
      Begin
        If WhereY > 23 Then
          Begin
            Varj ;
            ClrScr ;
          End ;
        Write(T[I].Kulcs:5) ;
      End ;
    WriteLn ;
  End ;

Procedure Csere(Var Elem1, Elem2: ElemTip) ;
  Var
    Ment : ElemTip ;
  Begin
    Ment := Elem1 ;
    Elem1 := Elem2 ;
    Elem2 := Ment ;
  End ;

Procedure Rendez_Minvalaszt(T: TombTip) ;
  Var
    I,
    J,
    Min : Word ;
  Begin
    StopperBe ;
    For I := 1 To Elemszam - 1 Do
      Begin
        Min := I ;
        For J := I + 1 To Elemszam Do
          If T[J].Kulcs < T[Min].Kulcs Then
            Min := J ;
        Csere(T[I],T[Min]) ;
      End ;
    StopperKi ;
  End ;

Procedure Rendez_Szomszedcsere(T: TombTip) ;
  Var
    I,
    J  : Word ;
    Ok : Boolean ;
  Begin
    StopperBe ;
    I := ElemSzam - 1 ;
    Ok := False ;
    While (I >= 1) And Not Ok Do
      Begin
        Ok := True ;
        For J := 1 To I Do
          If T[J].Kulcs > T[J + 1].Kulcs Then
            Begin
              Csere(T[J],T[J + 1]) ;
              Ok := False ;
            End ;
        Dec(I) ;
      End ;
    StopperKi ;
  End ;

Procedure Rendez_Beszur(T: TombTip) ;
  Var
    Ment : ElemTip ;
    I,
    J    : Word ;
  Begin
    StopperBe ;
    T[0].Kulcs := -MaxInt ;
    For I := 2 To ElemSzam Do
      Begin
        If T[I].Kulcs < T[I - 1].Kulcs Then
          Begin
            Ment := T[I] ;
            J := I ;
            Repeat
                Dec(J) ;
                T[J + 1] := T[J] ;
            Until T[J - 1].Kulcs <= Ment.Kulcs ;
            T[J] := Ment ;
          End ;
      End ;
    StopperKi ;
  End ;

Procedure Rendez_Shell(T: TombTip) ;
  Var
    Ment     : ElemTip ;
    LepesKoz,
    Kezd,
    I,
    J        : Word ;
  Begin
    StopperBe ;
    LepesKoz := Elemszam ;
    T[0].Kulcs := -MaxInt ;
    Repeat
        LepesKoz := LepesKoz Div 3 + 1 ;
        For Kezd := 1 To LepesKoz Do
          Begin
            I := Kezd + LepesKoz ;
            While I <= Elemszam Do
              Begin
                If T[I].Kulcs < T[I - LepesKoz].Kulcs Then
                  Begin
                    J := I ;
                    Ment := T[I] ;
                    Repeat
                        Dec(J,LepesKoz) ;
                        T[J + LepesKoz] := T[J] ;
                    Until (J <= Kezd) Or (T[J - LepesKoz].Kulcs <= Ment.Kulcs) ;
                    T[J] := Ment ;
                  End ;
                Inc(I,LepesKoz) ;
              End ;
          End ;
    Until LepesKoz = 1 ;
    StopperKi ;
  End ;

Procedure Rendez_Quick(Var T: TombTip) ;

  Procedure Quick(Bal,Jobb: Word) ;
    Var
      I,
      J            : Word ;
      KozepsoKulcs : Integer ;
    Begin
      I := Bal ;
      J := Jobb ;
      KozepsoKulcs := T[(I + J) Div 2].Kulcs ;
      While I <= J Do
        Begin
          While T[I].Kulcs < KozepsoKulcs Do
            Inc(I) ;
          While T[J].Kulcs > KozepsoKulcs Do
            Dec(J) ;
          If I <= J Then
            Begin
              Csere(T[I],T[J]) ;
              Inc(I) ;
              Dec(J) ;
            End ;
        End ;
      If Bal < J Then
        Quick(Bal,J) ;
      If I < Jobb Then
        Quick(I,Jobb) ;
    End ;

  Begin
    StopperBe ;
    Quick(1,Elemszam) ;
    StopperKi ;
  End ;

Begin
  ClrScr ;
  Tomb_General ;

  WriteLn('Rendezs minimlis elem kivlasztsval:') ;
  Rendez_Minvalaszt(Tomb) ;
  WriteLn('  rendezsi id: ',IdoMp:5:2) ;

  WriteLn('Rendezs szomszdos elemek cserjvel:') ;
  Rendez_Szomszedcsere(Tomb) ;
  WriteLn('  rendezsi id: ',IdoMp:5:2) ;
  WriteLn('Rendezs beszrssal:') ;
  Rendez_Beszur(Tomb) ;
  WriteLn('  rendezsi id: ',IdoMp:5:2) ;

  WriteLn('Rendezs Shell mdszervel:') ;
  Rendez_Shell(Tomb) ;
  WriteLn('  rendezsi id: ',IdoMp:5:2) ;

  WriteLn('Gyorsrendezs:') ;
  Rendez_Quick(Tomb) ;
  WriteLn('  rendezsi id: ',IdoMp:5:2) ;

  WriteLn('A tmb kulcsainak kirsa kvetkezik: ') ;
  Varj ;
  Kulcs_Kiir(Tomb) ;
  Varj ;
End.
