{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB14.PAS                }
{-----------------------------------------}

Program Tomb14 ;

Uses
  Crt ;

Const
  Beszuro_Mod : Boolean = True ;
  BS       = #8 ;
  Enter    = #13 ;
  ESC      = #27 ;
  SPC      = ' ' ;
  UpKey    = #200 ;
  DownKey  = #208 ;
  LeftKey  = #203 ;
  RightKey = #205 ;
  HomeKey  = #199 ;
  EndKey   = #207 ;
  InsKey   = #210 ;
  DelKey   = #211 ;

Type
  Karakterhalmaz = Set Of Char ;
  Mezotip        = Record
                     X,Y, Hossz    : Byte ;
                     Tartalom      : String ;
                     Engedelyezett : Karakterhalmaz ;
                   End ;

Const
  Mezo : Array[1..3] Of Mezotip =
         ((X: 20 ; Y: 12 ; Hossz: 20 ; Tartalom: '' ;
           Engedelyezett: ['a'..'z','A'..'Z']),
          (X: 20 ; Y: 14 ; Hossz: 6 ; Tartalom: '' ;
           Engedelyezett: ['0'..'9']),
          (X: 28 ; Y: 14 ; Hossz: 1 ; Tartalom: '' ;
           Engedelyezett: ['$','','%'])) ;

Var
  MezoInd     : Byte ;
  BefKar      : Char ;

Procedure PufferUrit ;
  Var
    Ch : Char ;
  Begin
    While KeyPressed Do
      Ch := Readkey ;
  End ;

Function BillKod : Char ;
  Var
    Ch : char ;
  Begin
    Ch := ReadKey ;
    If (Ch = #0) And KeyPressed Then
      Begin
        Ch := ReadKey ;
        If Ord(Ch) < 128 Then
          Inc(Ch,128) ;
      End ;
    BillKod := Ch ;
  End ;

Procedure Hibahang ;
  Begin
    Sound(440) ;
    Delay(40) ;
    Nosound ;
  End ;

Procedure Bevitel(Var S                  : String ;
                      X,Y,Hossz          : Byte ;
                      Bevihetok,Befejezok: Karakterhalmaz ;
                  Var Befejezo           : Char) ;
  Var
    Poz : Byte ;
    Kar : Char ;
  Begin
    GotoXY(X,Y) ;
    Write(S,'':Hossz - Length(S)) ;
    Poz := 0 ;
    Repeat
        GotoXY(X + Poz,Y) ;
        PufferUrit ;
        Kar := BillKod ;
        If Not (Kar In Befejezok) Then
          Case Kar Of
            #32..#186 : If (Poz < Hossz) And (Kar In Bevihetok)
                        Then
                          Begin
                            Inc(Poz) ;
                            If Beszuro_Mod
                            Then
                              Begin
                                If Length(S) = Hossz Then
                                  Delete(S,Hossz,1) ;
                                Insert(Kar,S,Poz) ;
                                Write(Copy(S,Poz,Hossz)) ;
                              End
                            Else
                              Begin
                                If Poz > Length(S)
                                Then
                                  S := S + Kar
                                Else
                                  S[Poz] := Kar ;
                                Write(Kar) ;
                              End ;
                          End
                        Else
                          Hibahang ;
            ^S,
            LeftKey   : If Poz > 0
                        Then
                          Dec(Poz)
                        Else
                          Hibahang ;
            ^D,
            RightKey  : If Poz < Length(S)
                        Then
                          Inc(Poz)
                        Else
                          Hibahang ;
            ^A,
            HomeKey   : Poz := 0 ;
            ^F,
            EndKey    : Poz := Length(S) ;
            ^G,
            DelKey    : If Poz < Length(S)
                        Then
                          Begin
                            Delete(S,Poz + 1,1) ;
                            Write(Copy(S,Poz + 1,Hossz),' ') ;
                          End
                        Else
                          Hibahang ;
            BS        : If Poz > 0
                        Then
                          Begin
                            Delete(S,Poz,1) ;
                            GotoXY(X + Poz - 1,Y) ;
                            Write(Copy(S,Poz,Hossz),' ') ;
                            Dec(Poz) ;
                          End
                        Else
                          Hibahang ;
            ^Y        : Begin
                          Write('':Hossz-Poz) ;
                          Delete(S,Poz + 1,Hossz) ;
                        End ;
            InsKey    : Beszuro_Mod := Not Beszuro_Mod ;
          End ;
    Until Kar In Befejezok ;
    Befejezo := Kar ;
  End ;

Begin
  TextBackground(Blue) ;
  ClrScr ;
  TextBackground(Lightgray) ;
  TextColor(Black) ;
  For MezoInd := 1 To 3 Do
    With Mezo[MezoInd] Do
      Begin
        GotoXY(X,Y) ;
        Write(SPC:Hossz) ;
      End ;

  MezoInd := 1 ;
  Repeat
      With Mezo[MezoInd] Do
        Bevitel(Tartalom,X,Y,Hossz,Engedelyezett,
                [Enter,UpKey,DownKey,ESC],BefKar) ;
      Case BefKar Of
        UpKey   : If MezoInd > 1 Then
                    Dec(MezoInd) ;
        Enter,
        DownKey : If MezoInd < 3
                  Then
                    Inc(MezoInd)
                  Else
                    MezoInd := 1 ;
      End ;
  Until BefKar = ESC ;
  TextBackground(Black) ;
  TextColor(LightGray) ;
  ClrScr ;
End.
