{-----------------------------------------}
{    Angster Erzsbet - Kertsz Lszl    }
{  Turbo Pascal 6.0 feladatgyjtemny I.  }
{              lemezmellklet             }
{                                         }
{               TOMB17.PAS                }
{-----------------------------------------}

Program Tomb17 ;

Uses
  Crt ;

Const
  Maxhet = 8 ;

Type
  St10             = String[10] ;
  Allampolgarsagok = (Angol, Belga, Francia, Holland,
                      Magyar, Nemet, Olasz, Osztrak) ;
  Korcsoportok     = 0..9 ;
  Hetek            = 0..Maxhet ;
  Nemek            = (Ferfi,No) ;
  StatTip          = Array[Allampolgarsagok,Korcsoportok,
                           Nemek,Hetek] Of Word ;

Const
  AllampolgarsagokSt : Array [Allampolgarsagok] Of St10 =
    ('Angol','Belga','Francia','Holland',
     'Magyar','Nemet','Olasz','Osztrak') ;

Var
  Stat           : StatTip ;
  StatMent       : File Of StatTip ;
  Nem            : Nemek ;
  Kor,
  TartHet        : Byte ;
  Allampolgarsag : Allampolgarsagok ;
  Vege           : Boolean ;

Procedure Informacio ;
  Var
    A : Allampolgarsagok ;
  Begin
    Write('llampolgrsgok: ') ;
    For A := Angol To Osztrak Do
      Write(AllampolgarsagokSt[A],' ') ;
    WriteLn ;
    WriteLn('Kor: 0-99') ;
    WriteLn('Nemek: No, Ferfi') ;
    WriteLn('Tartozkodsi ht: 0-',MaxHet) ;
    WriteLn ;
  End ;

Function NagyKis(S: String) : String ;
  Var
    I : Byte ;
  Begin
    S[1] := Upcase(S[1]) ;
    For I := 2 To Length(S) Do
      If S[I] In ['A'..'Z'] Then
        S[I] := Chr(Ord(S[I]) + 32) ;
    NagyKis := S ;
  End ;

Function Szam(Tol, Ig: LongInt) : LongInt ;
  Var
    X,
    Y : Byte ;
    L : LongInt ;
  Begin
    X := WhereX ;
    Y := WhereY ;
    {$I-}
    Repeat
        GotoXY(X,Y) ;
        ClrEol ;
        ReadLn(L) ;
    Until (IOResult = 0) And (L >= Tol) And (L <= Ig) ;
    {$I+}
    Szam := L ;
  End ;

Function NemBe : Nemek ;
  Var
    X,
    Y  : Byte ;
    St : St10 ;
  Begin
    X := WhereX ;
    Y := WhereY ;
    Repeat
        GotoXY(X,Y) ;
        ClrEol ;
        ReadLn(St) ;
        St := NagyKis(St) ;
    Until (St = 'Ferfi') Or (St = 'No') ;
    If St = 'Ferfi'
    Then
      NemBe := Ferfi
    Else
      NemBe := No ;
  End;

Function AllamPolgBe : Allampolgarsagok ;
  Var
    X,
    Y  : Byte ;
    St : St10 ;
    A  : Allampolgarsagok ;
  Begin
    X := WhereX ;
    Y := WhereY ;
    Repeat
        GotoXY(X,Y) ;
        ClrEol ;
        ReadLn(St) ;
        St := NagyKis(St) ;
        A := Angol ;
        While (St <> AllampolgarsagokSt[A]) And (A < Osztrak) Do
          Inc(A) ;
        Vege := St = '' ;
    Until (St = AllampolgarsagokSt[A]) Or Vege;
    AllampolgBe := A ;
  End ;

Function Korcsoport(Kor: Byte): Korcsoportok ;
  Begin
    Korcsoport := Kor Div 10 ;
  End ;

Procedure Statisztika1 ;
  Var
    OsszPolg,
    OsszHet        : Word ;
    Allampolgarsag : Allampolgarsagok ;
    Korcsoport     : Korcsoportok ;
    Atlag          : Real ;
  Begin
    WriteLn('A klnboz ni llampolgrok tlag tartzkodsi ' +
            'ideje: ') ;
    For Allampolgarsag := Angol To Osztrak Do
      Begin
        OsszPolg := 0 ;
        OsszHet := 0 ;
        For Korcsoport := 0 To 9 Do
          For TartHet := 0 to Maxhet Do
            Begin
              Inc(OsszPolg,
                  Stat[Allampolgarsag,Korcsoport,No,TartHet]) ;
              Inc(OsszHet,
                  Stat[Allampolgarsag,Korcsoport,No,TartHet] * TartHet) ;
            End ;
        Write(AllampolgarsagokSt[Allampolgarsag]) ;
        GotoXY(10,WhereY) ;
        Write(': ') ;
        If OsszPolg > 0
        Then
          Atlag := OsszHet / OsszPolg
        Else
          Atlag := 0 ;
        WriteLn(Atlag:3:1,'  ht') ;
      End ;
    WriteLn ;
  End ;

Procedure Statisztika2 ;
  Var
    Gyujto     : Array[Korcsoportok] Of Word ;
    Korcsoport : Korcsoportok ;
    Ossz       : Word ;
    Szazal     : Real ;
  Begin
    Ossz := 0 ;
    For Korcsoport := 0 To 9 Do
      Begin
        Gyujto[Korcsoport] := 0 ;
        For Allampolgarsag := Angol To Osztrak Do
          For Nem := Ferfi To No Do
            For TartHet := 0 To Maxhet Do
              Inc(Gyujto[Korcsoport],
                  Stat[Allampolgarsag,Korcsoport,Nem,TartHet]) ;
        Inc(Ossz,Gyujto[Korcsoport]) ;
      End ;
    WriteLn('Korcsoport szerinti szzalkos megoszls:') ;
    For Korcsoport := 0 To 9 Do
      Begin
        If Ossz > 0
        Then
          Szazal := Gyujto[Korcsoport] * 100 / Ossz
        Else
          Szazal := 0 ;
        WriteLn(10 * Korcsoport:2,'-',10 * Korcsoport + 9:2,
                ': ',Szazal:6:2,' %') ;
      End ;
    WriteLn ;
  End ;

Procedure Statisztika3 ;
  Var
    Allampolgarsag : Allampolgarsagok ;
    Nem       : Nemek ;
    TartHet   : Hetek ;
    Osszes    : Word ;
  Begin
    Osszes := 0 ;
    For TartHet := 0 To Maxhet Do
      Inc(Osszes,Stat[Holland,4,Ferfi,TartHet]) ;
    WriteLn('A hatrt tlp 40-49 ves holland frfiak szma: ',Osszes) ;
  End ;

Begin
  ClrScr ;
  Assign(StatMent,'Stat.Dat') ;
  {$I-}
  Reset(StatMent) ;
  {$I+}
  If IOResult = 0
  Then
    Begin
      Read(StatMent,Stat) ;
      Close(StatMent) ;
    End
  Else
    FillChar(Stat,SizeOf(Stat),#0) ;

  Informacio ;
  Window(10,10,70,25) ;
  Write('llampolgrsg   : ') ;
  Allampolgarsag := AllampolgBe ;
  Vege := False ;

  While Not Vege Do
    Begin
      Write('Kor              : ') ;
      Kor := Szam(0,99) ;
      Write('Nem              : ') ;
      Nem := NemBe ;
      Write('Tartzkodsi id : ') ;
      TartHet := Szam(0,MaxHet) ;

      Inc(Stat[Allampolgarsag,Korcsoport(Kor),Nem,TartHet]) ;
      WriteLn ;

      ClrScr ;
      Write('llampolgrsg   : ') ;
      Allampolgarsag := AllampolgBe ;
    End ;

  Rewrite(StatMent) ;
  Write(StatMent,Stat) ;
  Close(StatMent) ;

  Window(1,1,80,25) ;
  ClrScr ;
  Statisztika1 ;
  Statisztika2 ;
  Statisztika3 ;
  ReadLn ;
End.
